|
| 1 | +package com.stevesun.solutions; |
| 2 | + |
| 3 | +import java.util.HashMap; |
| 4 | +import java.util.List; |
| 5 | +import java.util.Map; |
| 6 | + |
| 7 | +/** |
| 8 | + * There is a brick wall in front of you. The wall is rectangular and has several rows of bricks. The bricks have the same height but different width. You want to draw a vertical line from the top to the bottom and cross the least bricks. |
| 9 | +
|
| 10 | + The brick wall is represented by a list of rows. Each row is a list of integers representing the width of each brick in this row from left to right. |
| 11 | +
|
| 12 | + If your line go through the edge of a brick, then the brick is not considered as crossed. You need to find out how to draw the line to cross the least bricks and return the number of crossed bricks. |
| 13 | +
|
| 14 | + You cannot draw a line just along one of the two vertical edges of the wall, in which case the line will obviously cross no bricks. |
| 15 | +
|
| 16 | + Example: |
| 17 | + Input: |
| 18 | + [[1,2,2,1], |
| 19 | + [3,1,2], |
| 20 | + [1,3,2], |
| 21 | + [2,4], |
| 22 | + [3,1,2], |
| 23 | + [1,3,1,1]] |
| 24 | + Output: 2 |
| 25 | + Explanation: |
| 26 | +
|
| 27 | + Note: |
| 28 | + The width sum of bricks in different rows are the same and won't exceed INT_MAX. |
| 29 | + The number of bricks in each row is in range [1,10,000]. The height of wall is in range [1,10,000]. Total number of bricks of the wall won't exceed 20,000. |
| 30 | + */ |
| 31 | +public class BrickWall { |
| 32 | + //credit to: https://leetcode.com/articles/brick-wall/ |
| 33 | + |
| 34 | + /**we make use of a HashMap |
| 35 | + map which is used to store entries in the form: |
| 36 | + (sum,count). Here, |
| 37 | + sum refers to the cumulative sum of the bricks' widths encountered in the current row, and |
| 38 | + count refers to the number of times the corresponding sum is obtained. Thus, |
| 39 | + sum in a way, represents the positions of the bricks's boundaries relative to the leftmost boundary. |
| 40 | +
|
| 41 | + This is done based on the following observation: |
| 42 | + We will never obtain the same value of sum twice while traversing over a particular row. |
| 43 | + Thus, if the sum value is repeated while traversing over the rows, it means some row's brick boundary coincides with some previous row's brick boundary. |
| 44 | + This fact is accounted for by incrementing the corresponding count value. |
| 45 | +
|
| 46 | + But, for every row, we consider the sum only upto the second last brick, since the last boundary isn't a valid boundary for the solution.*/ |
| 47 | + |
| 48 | + public int leastBricks(List<List<Integer>> wall) { |
| 49 | + Map<Integer, Integer> map = new HashMap(); |
| 50 | + for (List<Integer> row : wall) { |
| 51 | + int sum = 0; |
| 52 | + for (int i = 0; i < row.size()-1; i++) {//NOTE: i < row.size()-1 |
| 53 | + sum += row.get(i); |
| 54 | + if (map.containsKey(sum)) map.put(sum, map.get(sum)+1); |
| 55 | + else map.put(sum, 1); |
| 56 | + } |
| 57 | + } |
| 58 | + int result = wall.size(); |
| 59 | + for (int key : map.keySet()) { |
| 60 | + result = Math.min(result, wall.size() - map.get(key)); |
| 61 | + } |
| 62 | + return result; |
| 63 | + } |
| 64 | + |
| 65 | +} |
0 commit comments